// OB17
// 11-9-2013
// Fait avec Processing 2.02
//
// Utilise la library controlP5, Download:
// http://www.sojamo.de/libraries/controlP5/
//
// Utilise la library minim v3.0 BETA inclus dans Processing 2.0.2:
//
// Barre d'espace: Play / Stop Ecoute Poeme
//         a ou A:   On / Off  Alea
//         z ou Z: Re-initialisation
//
// Ligne 35: PleinEcran true ou false

import controlP5.*; // Pour les boutons et les menus deroulants
import ddf.minim.*;

ControlP5 DesBoutons, Menu;
ListBox Liste;
float angle2;
PImage img;

int count = 3;
int HauteurLigne = 30;
int XMenu = 950;
int YMenu = 70;
int Mot = 0;
int TempsMillis;

int Voix = 1;

boolean PleinEcran = false;
boolean Ecoute = false, Alea = false;
String NomFichier;

String[] Poeme = { 
  "", 
  "Mon oiseau bleu", "a le ventre", "tout bleu", 
  "Sa tête est", "d'un vert", "mordoré", 
  "Il a une", "tache", "noire", "sous la", "gorge", 
  "Ses ailes", "sont", "bleues", 
  "avec des", "touffes de", "petites", "plumes", "jaune doré", 

  "Au bout", "de la queue", "il y a des", 
  "traces de", "vermillon", 
  "Son dos est", "zébré", "de noir et", "de vert", 
  "Il a le", "bec noir", "les pattes", "incarnat", 
  "et deux petits", "yeux de jais", 

  "Il adore", "faire trempette,", 
  "se nourrit", "de bananes et", "pousse un", 
  "cri", "qui ressemble", "au sifflement", 
  "d'un tout petit", "jet de vapeur.", 

  "On le nomme", "le septicolore", 

  "Blaise Cendrars"
};

int NombreMot = Poeme.length;

Minim minim;

// AudioPlayer[] player = new AudioPlayer[NombreMot];
// Voir: http://code.compartmental.net/tools/minim/manual-audiosnippet/
// Voir: http://code.compartmental.net/tools/minim/manual-playable/
// http://code.compartmental.net/tools/minim/manual-audiosample/
AudioSnippet[] player = new AudioSnippet[NombreMot];
// Bug vu sous MacOSX6 ou X7: le son disparait quand on minim.loadfile() plus de 33 AudioPlayer
// Pas de bug sous Win7
// Pas de bug avec AudioSnippet au lieu de AudioPlayer

int[] PositionX = { 
  550, // 0
  0, 172, 282, // 1 2 3
  0, 112, 204, // 4 5 6
  0, 82, 146, 204, 284, // 7 8 9 10 11
  0, 100, 154, // 12 13 14
  0, 98, 204, 
  0, 80, // 15 16 17 18 19
  0, 90, //20 21
  0, 96, 196, //22,23,24,
  0, 124, 188, 286, //25,26,27,28,
  0, 60, 146, 248, //29,30,31,32,
  0, 136, //33,34
  0, 82, // 35, 36
  0, 100, 246, //37,38,39,
  0, 32, 178, //40,41,42,
  0, 140, //43,44
  0, 136, //45 46
  0, //47
};
int[] PositionY = { 
  60, 
  0, 0, 0, 
  30, 30, 30, 
  60, 60, 60, 60, 60, 
  90, 90, 90, 
  120, 120, 120, 
  150, 150, 
  180, 180, 
  240, 240, 240, 
  270, 270, 270, 270, 
  300, 300, 300, 300, 
  330, 330, 
  390, 390, 
  420, 420, 420, 
  450, 450, 450, 
  480, 480, 
  540, 540, 
  600
};
int[] TailleX = { 
  50, // 0
  172, 110, 90, // 1 2 3
  114, 92, 94, // 4 5 6
  82, 64, 58, 80, 68, // 7 8 9 10 11
  100, 54, 74, // 12 13 14
  98, 106, 74, 
  80, 112, // 15 16 17 18 19
  90, 120, //20 21
  96, 100, 98, //22,23,24,
  124, 64, 98, 76, //25,26,27,28,
  60, 86, 102, 86, //29,30,31,32,
  136, 124, //33,34
  82, 152, // 35 36
  100, 146, 112, //37,38,39,
  32, 146, 134, //40,41,42,
  140, 140, //43,44
  136, 138, //45 46
  168          //47
};

color[] Couleurs = { 
  color(50, 50, 50), color(56, 0, 255), color(56, 0, 255), 
  color(101, 252, 139), color(101, 252, 139), color(255, 187, 0), 
  color(255, 187, 0), color(255, 212, 205), color(255, 212, 205), 
  color(254, 255, 189), color(254, 255, 189), color(254, 24, 0), 
  color(254, 24, 0), color(164, 0, 245), color(164, 0, 245), 
  color(102, 232, 254), color(102, 232, 254), color(0, 205, 52), 
  color(0, 205, 52), color(250, 251, 0), color(250, 251, 0), 
  color(100, 100, 100)
};

void setup() {
  size(1024, 768);  // "The size() function must be the first line in setup()"
  //background(myColor);
  angle2 = 0;
  img = loadImage("oiseau1.png");
  println("NombreMot = " + NombreMot);
  minim = new Minim(this);

  PFont pfont = createFont("Arial", 20, true); // use true/false for smooth/no-smooth
  ControlFont font = new ControlFont(pfont, 241);

  Menu = new ControlP5(this);
  Menu.setControlFont(pfont, 20);
  Liste = Menu.addListBox("Menu")
    .setPosition(XMenu, YMenu)
      .setSize(60, 630)
        .setItemHeight(HauteurLigne)
          .setBarHeight(HauteurLigne)
            .setColorBackground(color(200, 200, 200))
              .setColorActive(color(0))
                .setColorForeground(Couleurs[21])
                  .setScrollbarWidth(0)
                    .enableCollapse()
                      ;
  Liste.captionLabel()
    .toUpperCase(false)
      .set("")
        .setColor(0);
  Liste.captionLabel().style().marginLeft = 4;
  Liste.captionLabel().style().marginTop = 2;
  Liste.captionLabel()
    .setFont(font)
      .setSize(20)
        .toUpperCase(false)
          ;
  // CreationMenu("20 Couleurs", Liste);
  Liste.actAsPulldownMenu(false);
  CreationMenu("", Liste);

  DesBoutons = new ControlP5(this);
  for (int i = 1; i < NombreMot; i = i+1) {
    DesBoutons.addButton(Poeme[i])
      .setValue(0)
        .setPosition(PositionX[0] + PositionX[i], PositionY[0] + PositionY[i])
          .setSize(TailleX[i], 30)
            ;
    DesBoutons.getController(Poeme[i])
      .getCaptionLabel()
        .setFont(font)
          .toUpperCase(false)
            .setSize(22)
              ;
  }
  Init();
  Liste.hide();
}

void CreationMenu(String Mot, ListBox MaList) {
  for (int i=1;i<21;i++) {
    ListBoxItem lbi = MaList.addItem(Mot + " " + i, i);
    lbi.setColorBackground(Couleurs[i]);
  }
}

void controlEvent(ControlEvent theEvent) {
  if (theEvent.isGroup()) {
    if (theEvent.name().equals("Menu")) {
      Voix = (int)theEvent.group().value();
      // println("Voix " + Voix);
      DesBoutons.getController(Poeme[Mot])
        .setColorBackground(Couleurs[Voix]) // Couleur du fond
          ;
      DesBoutons.getController(Poeme[Mot])//
        .getCaptionLabel()
          .setColor(color(0, 0, 0)) // Couleur du Texte
            ;
      // player[Mot] = minim.loadFile(char(64 + Voix) + "/" + TransformeString(Poeme[Mot]) + ".wav", 2048);
      player[Mot] = minim.loadSnippet(char(64 + Voix) + "/" + TransformeString(Poeme[Mot]) + ".wav");
      println("Mot " + Mot + " " + Poeme[Mot] + "    Voix " + char(64 + Voix));
      player[Mot].play(0);
      angle2 += 1;
      Liste.hide();
    }
  } 
  else {
    String Evenement = theEvent.getController().getName();
    //println("Event = " + Evenement); 
    for (int i = 1; i < NombreMot; i++) {
      if (Evenement.equals(Poeme[i])) {
        Mot = i;
        Liste.show();
      }
    }
  }
}


void draw() {
  background(0);

  pushMatrix();
  translate(270, 380);
  rotate(radians(angle2));
  //fill(0, 255, 0);
  image(img, 0, 0);
  // angle2 -= 1;
  imageMode(CENTER);
  popMatrix();

  if (Ecoute) {
    // println("millis = "+ millis() + "     position = " + player[count].position());
    // player[].isPlaying() ne fonctionne pas avec AudioSnippet
    // player[].position() ne fonctionne pas avec AudioSnippet
    if (millis() > TempsMillis) {
      if (Alea) {
        count = int(random(NombreMot-1) + 1);
      }
      else {
        count++;
      } 
      // println("count = " + count + "    Length = " + player[count].length());
      println("count = " + count);
      if (count >= NombreMot) {
        Ecoute = false;
      }
      else {
        player[count].play(0);
        TempsMillis = millis() + player[count].length();
      }
    }
  }
}

void keyReleased() {
  if (key == ' ') { // Barre d'espace
    println("Barre d'espace");
    // Ecoute = true;
    Ecoute = !Ecoute;
    if (Ecoute) {
      count = 1;
      player[count].play(0);
      TempsMillis = millis() + player[count].length();
    }
    else {
    }
  }
  if ((key == 'a') || (key == 'A')) { // a ou A
    println("A");
    Alea = !Alea;
  }
  if ((key == 'z') || (key == 'Z')) { // z ou Z
    println("Z");
    Init();
  }
}

String TransformeString(String Chaine) {
  String C;
  C = join(split(Chaine, ' '), "_"); // Remplacement des espaces par des underscores
  C = join(split(     C, "'"), "_"); // Remplacement des apostrophes par des underscores
  C = join(split(     C, ','), "" ); // Suppression des ,
  C = join(split(     C, '.'), "" ); // Suppression des .
  C = join(split(     C, 'é'), "e"); // Remplacement des é par des e
  C = join(split(     C, 'è'), "e"); // Remplacement des è par des e
  C = join(split(     C, 'ê'), "e"); // Remplacement des ê par des e
  return C;
}

void Init() {
  println("Init");
  for (int i = 1; i < NombreMot; i = i+1) {
    DesBoutons.getController(Poeme[i])
      .getCaptionLabel().setColor(color(100, 100, 100)) // Couleur du Texte
        ;
    DesBoutons.getController(Poeme[i])
      .setColorBackground(color(0, 0, 0)) // Couleur du fond
        ;
    player[i] = minim.loadSnippet(char(65) + "/" + TransformeString(Poeme[i]) + ".wav"); //Initialiation des 47 player avec la voix  A
    // println(i + "  " + TransformeString(Poeme[i]));
  };
}

void stop() {
  println("Stop");
  // always close Minim audio classes when you finish with them
  for (int i = 1; i < NombreMot; i = i+1) {
    player[i].close();
  };
  minim.stop();
  super.stop();
}

boolean sketchFullScreen() {
  return PleinEcran;
}

